#!/usr/bin/env python3
# -*- coding: utf-8; -*-




from katoptron.eigenvalues import *
import os
import fwk
from scipy import sparse
import matplotlib.pyplot as plt

def test1():
    try:
        import mpi4py.MPI as mpi
        comm = mpi.COMM_WORLD
        rank = comm.rank
        siz = comm.size
        name = mpi.Get_processor_name()
        status = mpi.Status()
    except:
        comm = None
        rank = 0
        siz = 1
        name = "noname"

    file_dir = os.path.dirname(__file__)
    work_dir = os.getcwd()

    input_file_dir = '/Users/kimliegeois/Desktop/gaston'

    filename_GT = input_file_dir + '/B_mm.txt'

    GT_gaston = read_mm(filename_GT)

    X = np.loadtxt(filename_GT, skiprows=2)

    row_gaston = X[:, 0].astype(int)-1
    col_gaston = X[:, 1].astype(int)-1
    data_gaston = X[:, 2]    

    input_file_dir = '/Users/kimliegeois/Desktop/blake'

    filename_GT = input_file_dir + '/B_mm.txt'

    GT_blake = read_mm(filename_GT)

    X = np.loadtxt(filename_GT, skiprows=2)

    row_blake = X[:, 0].astype(int)-1
    col_blake = X[:, 1].astype(int)-1
    data_blake = X[:, 2]   

    nNode = 341

    plot_indices = np.arange(80,120,1,dtype=int)

    print(col_gaston[plot_indices])
    print(col_blake[plot_indices])

    indT = np.argwhere(col_gaston <= nNode)
    indMech = np.argwhere(col_gaston > nNode)


    col_gaston_2 = np.copy(col_gaston)

    col_gaston_2[indT] = (col_gaston[indT]+1)*4-1

    indexNodes =  np.floor((col_gaston_2[indMech] - nNode)/3.)
    rest = (col_gaston_2[indMech] - nNode) - 3*indexNodes

    plt.figure()
    plt.plot(indexNodes[plot_indices],'*')

    plt.figure()
    plt.plot(rest[plot_indices],'*')

    col_gaston_2[indMech] = indexNodes*4+rest

    #print(col_gaston[0:30])
    print(col_gaston_2[plot_indices])
    print(col_blake[plot_indices])

    print(np.amax(np.abs(data_gaston-data_blake)))
    print(np.amax(np.abs(col_gaston_2-col_blake)))
    print(np.amax(np.abs(row_gaston-row_blake)))

    plt.figure()
    plt.plot(col_gaston_2[plot_indices]-col_blake[plot_indices],'*')
    #plt.show()

def test2():
    try:
        import mpi4py.MPI as mpi
        comm = mpi.COMM_WORLD
        rank = comm.rank
        siz = comm.size
        name = mpi.Get_processor_name()
        status = mpi.Status()
    except:
        comm = None
        rank = 0
        siz = 1
        name = "noname"

    file_dir = os.path.dirname(__file__)
    work_dir = os.getcwd()

    input_file_dir = '/Users/kimliegeois/Desktop/gaston'

    filename_GT = input_file_dir + '/B_T_mm.txt'

    GT_gaston = read_mm(filename_GT)

    X = np.loadtxt(filename_GT, skiprows=2)

    row_gaston = X[:, 0].astype(int)-1
    col_gaston = X[:, 1].astype(int)-1
    data_gaston = X[:, 2]    

    input_file_dir = '/Users/kimliegeois/Desktop/blake'

    filename_GT = input_file_dir + '/B_T_mm.txt'

    GT_blake = read_mm(filename_GT)

    X = np.loadtxt(filename_GT, skiprows=2)

    row_blake = X[:, 0].astype(int)-1
    col_blake = X[:, 1].astype(int)-1
    data_blake = X[:, 2]   

    nNode = 341

    indT = np.argwhere(row_gaston <= nNode)
    indMech = np.argwhere(row_gaston > nNode)

    plot_indices = np.arange(80,120,1,dtype=int)

    row_gaston_2 = np.copy(row_gaston)

    row_gaston_2[indT] = (row_gaston[indT]+1)*4-1

    indexNodes =  np.floor((row_gaston_2[indMech] - nNode)/3.)
    rest = (row_gaston_2[indMech] - nNode) - 3*indexNodes

    plt.figure()
    plt.plot(indexNodes[plot_indices],'*')

    plt.figure()
    plt.plot(rest[plot_indices],'*')

    row_gaston_2[indMech] = indexNodes*4+rest



    row_gaston_order = row_gaston_2*100+col_gaston
    row_blake_order = row_blake*100+col_blake

    order_gaston = np.argsort(row_gaston_order)
    order_blake = np.argsort(row_blake_order)

    print(row_gaston_2[plot_indices])
    print(row_blake[plot_indices])

    print(np.amax(np.abs(data_gaston[order_gaston]-data_blake[order_blake])))
    print(np.amax(np.abs(row_gaston_2[order_gaston]-row_blake[order_blake])))
    print(np.amax(np.abs(col_gaston[order_gaston]-col_blake[order_blake])))


    #print(np.sum(row_gaston_2-row_blake))

    plt.figure()
    plt.plot(row_gaston_2[order_gaston]-row_blake[order_blake],'*')
    #plt.show()

def main():
    test2()

if __name__ == "__main__":
    main()
